!function() {
    window.XWebViewApi = {
        call: function(fun, param) {
            return window.prompt("invokeXWebViewApi://" + fun, param);
        },
        localStorage: {
            removeItem: function(k) {
                XWebViewApi.call("localStorage.remove", JSON.stringify({key: k}));
            },
            getItem: function(k) {
                var p = JSON.stringify({key: k});
                var s = XWebViewApi.call("localStorage.contains", p);
                if (s === 'true') {
                    return XWebViewApi.call("localStorage.get", p);
                }

                return null;
            },
            setItem: function(k, v) {
                XWebViewApi.call("localStorage.set", JSON.stringify({key: k, value: v}));
            },
            key: function(idx) {
                var s = XWebViewApi.call("localStorage.key", JSON.stringify({index: idx}));
                return s == null ? '' : s;
            },
            size: function() {
                var s = parseInt(XWebViewApi.call("localStorage.size", JSON.stringify({})), 10);
                return isNaN(s) ? 0 : s;
            }
        },
        notifyLifecycle: function(state) {
            return XWebViewApi.call("lifecycle", state);
        },
        registerMenuCommand: function(domain, id, text, callback) {
            var menu = {domain:'', id:'', text:'', callback:''}
            menu.domain = domain;
            menu.id = id;
            menu.text = text;
            menu.callback = callback;
            return XWebViewApi.call("registerMenuCommand", JSON.stringify(menu));
        },
        unregisterMenuCommand: function(domain, id) {
            var menu = {domain:'', id:''}
            menu.domain = domain;
            menu.id = id;
            return XWebViewApi.call("unregisterMenuCommand", JSON.stringify(menu));
        },
        showNotification: function(scene, id, title, content, icon, duration, callback) {
            var notify = {}
            notify.scene = scene;
            notify.id = id;
            notify.title = title;
            notify.content = content;
            notify.icon = icon;
            notify.duration = duration;
            notify.callback = callback;
            return XWebViewApi.call("showNotification", JSON.stringify(notify));
        }
    };

    var ready = false;
    document.onreadystatechange = function() {
        console.log("dom onreadystatechange:" + document.readyState);

        if (document.readyState === "interactive" || document.readyState === "complete") {
            if (!ready) {
                ready = true;
                XWebViewApi.notifyLifecycle("interactive");
            }
        } else if (document.readyState === 'loading') {
            XWebViewApi.notifyLifecycle("loading");
        }
    }
}();